*************************************
*
; BouQLder QLash
; setup the playing field  & values
; (C) W. Lenerz 2018
*
**************************************

	section basic


	include 'dev1_basic_boulder_asm_keys'
	include 'dev8_keys_qlv'
	include 'dev8_keys_err'
	include 'dev8_keys_sbasic'
	include 'dev8_keys_qdos_io'
	include 'DEV8_keys_qdos_sms'

	xdef	bd_cave

; Copy the basic array passed as param (this is actually a slice)
; the caves are made up of a 22 rows * 40 cols grid =880 squares
; the array is DIMmed as DIM cv_data%(22,41)
; cols 0 and 41 are always 0
; cols 1 and 40 are always steel wall
; row  0 is always 0
; rows 1 and 22 are always steel wall


;*****************************************
;
; BD_CAVE wark_area,timer_adddress, array
;
******************************************


errbp	moveq	#err.ipar,d0
	rts

bd_cave
	move.w	sb.gtlin,a2
	subq.l	#8,a5
	jsr	(a2)			; get long integers
	bne.s	errbp			; ooops
	move.l	a5,a3
	subq.w	#2,d3			; there must be 2
	bne.s	errbp			; but there weren't
	addq.l	#8,sb_arthp(a6) 	; adjust maths stack
	move.l	(a6,a1.l),a5		; pointer to work space
	move.l	4(a6,a1.l),timer(a5)	; store timer address

; now get the pointer to the array (slice)
no_off	move.w	(a6,a3.l),d1		; d1 = type of parameter
	andi.w	#$f0f,d1
	cmpi.w	#$303,d1		; is it an integer array?
	bne	errbp			; no, so error	bad par
	move.l	4(a6,a3.l),d1		; d1=pointer to arr descriptor
	bmi	errbp			; if neg(=undefined): error bad par
	add.l	sb_datab(a6),d1 	; we point to the arr descriptor now
	move.l	d1,a4			;

	cmp.w	#2,4(a6,a4.l)		; must be max 2 dims
	bne.s	errbp			; else error->...
	move.l	(a6,a4.l),a4
	add.l	sb_datab(a6),a4 	; point to value for array
	add.l	a6,a4			; ***** SMSQE only
	move.l	array(a5),a0		; space for the data
	moveq	#rowsize+2,d0
	add.w	d0,d0
	sub.w	d0,a0			; point to start
	move.l	a0,a1
	move.w	#525,d0 		; copy 526 long words
bc_lp1	move.l	(a4)+,(a0)+
	dbf	d0,bc_lp1

; make the data for this level
	move.l	a1,a0			; start of "array"
	move.w	#2016,d0		; + 24 rows of 42 words -> last row in "array"
	add.w	d0,a1			; point to last row of data
	move.w	(a1)+,time(a5)		; cave time			0
	move.l	(a1)+,dia_val(a5)	; diamond normal & bonus values 1,2
	move.w	(a1)+,dia_req(a5)	; nbr of diamonds required for level				    3

; make diggeridoo position offset into array  + index as DBF loop counter
	move.l	(a1)+,d0		; diggeridoo col | row		  4,5
	move.l	d0,d1
	move.w	d0,d2
	mulu	#rowsize,d2		; row * rowsize
	clr.w	d0
	swap	d0			; row | col
	add.l	d0,d0			; col * 2 (word sized access)
	add.l	d0,d2
	add.l	a0,d2
	move.l	d2,a2
	move.l	d2,rok_pos(a5)
	move.w	#steelwl,(a2)		; at start, show steelwall
	moveq	#nbrrows,d0
	sub.w	d1,d0			; row
	swap	d0
	move.w	#nbrcols,d0
	swap	d1
	sub.w	d1,d0
	move.l	d0,entrylp(a5)		; position expressed in DBF rows and cols
	move.b	#2,entry(a5)		; flag how to display it

	move.l	(a1)+,amo_kwik(a5)	; amoeba time, mwall time	6,7

; make	outbox position offset into array + index as loop counter
	move.l	(a1)+,d0		; col | row		       8,9
	move.l	d0,d1
	move.w	d0,d2
	mulu	#rowsize,d2		; row * rowsize
	clr.w	d0
	swap	d0
	add.l	d0,d0			; col * 2 (word sized access)
	add.l	d0,d2
	add.l	a0,d2
	move.l	d2,exitloc(a5)
					; col row must become row/col in dbf
	moveq	#nbrrows,d0
	sub.w	d1,d0			; row
	swap	d0
	move.w	#nbrcols,d0
	swap	d1
	sub.w	d1,d0
	move.l	d0,extloop(a5)

; intermission status  and colours
	movem.w (a1)+,d0-d3		;			   10,11,12,13
	move.b	d0,intermi(a5)
		   
	addq.l	#4,a1			; jump over elements	   14,15

; set colours
; the sprites exist twice in mem :  first a wirking copy, then the original copy
; toset the new colours of the sprites:
; first copy original back to copy
; then check every colour in the copy and exchange it for the new colour
; (I should combine those loops)
	move.b	display(a5),d0		; display type
	sub.b	#16,d0			; mode 16?
	bne.s	tst_32			; ... no, try mode 32
	lea	sp16_cols,a4
	lea	sp16_orig,a2
	move.b	(a4,d1.w),d1		; new colours
	move.b	(a4,d2.w),d2
	move.b	(a4,d3.w),d3
	movem.w (a2)+,d4-d6		; orig colours
	move.l	spr_gen(a5),a4
	addq.l	#2,a4
	move.l	a4,a2
	add.l	#22272,a2		; 22272 = size of spr. file for mode 16
	move.l	a4,a0
	move.l	a2,a3
	move.w	#5567,d7		; 22272/4 = 5568 = size of sprites in LWs
cpylp1	move.l	(a3)+,(a0)+		; reset orig state
	dbf	d7,cpylp1
col16lp move.b	(a4)+,d0
	cmp.b	d4,d0
	bne.s	not16_1
	move.b	d1,-1(a4)
	bra.s	do16_lp
not16_1 cmp.b	d5,d0
	bne.s	not16_2
	move.b	d2,-1(a4)
	bra.s	do16_lp
not16_2 cmp.b	d6,d0
	bne.s	do16_lp
	move.b	d3,-1(a4)
do16_lp cmp.l	a4,a2
	bge.s	col16lp
	bra.s	set_0

tst_32	sub.b	#16,d0			; mode 32?
	bne.s	tst_33			; ... no, try 33
	lea	sp32_cols,a4		; ... yes, set olour tables
	lea	sp32_orig,a2
	bra.s	tst_wrd
tst_33	subq.b	#1,d0			; mode 33?
	bne	errbp			; ... no, so this is a problem!
	lea	sp33_cols,a4		; yes, set colour tables
	lea	sp33_orig,a2
tst_wrd add.w	d1,d1
	move.w	(a4,d1.w),d1		; new colours
	add.w	d2,d2
	move.w	(a4,d2.w),d2
	add.w	d3,d3
	move.w	(a4,d3.w),d3

	movem.w (a2)+,d4-d6		; orig colours

	move.l	spr_gen(a5),a4
	addq.l	#2,a4
	move.l	a4,a2
	add.l	#44544,a2		; /4 = 11135
	move.l	a4,a0
	move.l	a2,a3
	move.w	#11135,d7
cpylp2	move.l	(a3)+,(a0)+		; reset orig state
	dbf	d7,cpylp2

colr_lp move.w	(a4)+,d0
	cmp.w	d4,d0
	bne.s	not_1
	move.w	d1,-2(a4)
	bra.s	do_clp
not_1	cmp.w	d5,d0
	bne.s	not_2
	move.w	d2,-2(a4)
	bra.s	do_clp
not_2	cmp.w	d6,d0
	bne.s	do_clp
	move.w	d3,-2(a4)
do_clp	cmp.l	a4,a2
	bge.s	colr_lp

set_0
	move.l	(a1)+,d0		; start | end  column to display 16,17
	move.w	d0,endcol(a5)
	moveq	#nbrcols,d4
	sub.w	d0,d4
	move.w	d4,colend(a5)
	swap	d0
	move.w	d0,startcol(a5)
	moveq	#nbrcols+1,d4
	sub.w	d0,d4
	move.w	d4,colstrt(a5)

	st	amo_gro(a5)		; pretend amos can't grow anymore
	moveq	#0,d0
	move.l	d0,dying(a5)
	move.l	d0,spr_ani(a5)
	move.w	d0,rok_ani(a5)
	move.l	d0,mw_on(a5)
	move.w	d0,black(a5)
	move.w	d0,dia_got(a5)
	move.b	d0,exitbit(a5)
	move.b	d0,exit_ok(a5)

	rts


; colour changes
; the original colours are exchanged against the ones set for this level

; colours are in that order
; BLACK, WHITE, RED, GREEN
; BLUE, CYAN,PURPLE, YELLOW
; ORANGE,BROWN, GRAY1, GRAY2
; GRAY3, LIGHTRED, LIGHTGREEN, LIGHTBLUE
;
sp33_cols
	dc.w $0000,$FFFF,$4cd0,$ab57
	dc.w $42a6,$c3f2,$54e8,$d661
	dc.w $64cf,$5341,$6318,$8c62
	dc.w $AD6b,$7e1c,$e527,$7c72

sp32_cols
	dc.w $0000,$FFFF,$489A,$6B6D
	dc.w $1352,$197E,$949A,$B0CE
	dc.w $279B,$A06A,$0C63,$518C
	dc.w $75AD,$CEC3,$33A7,$D98B

sp16_cols
	dc.b $00,$ff,$54,$88
	dc.b $38,$bc,$39,$f8
	dc.b $52,$19,$1f,$e0
	dc.b $e3,$5e,$d7,$76


; In BDCFF files, the colour order is as follows:

; when there are 3 colours, the order is
; colour 1 = dirt
; colour 2 = steelwall & boulders
; colour 3 = brick wall & flies

; when there are 5 colours, the order is
; colour 1 = border
; colour 2 = space
; colour 3 = dirt
; colour 4 = steelwall & boulders
; colour 5 = wall & flies
;
; When 7 colours are present, then :
; colour 1 = border
; colour 2 = space
; colour 3 = dirt
; colour 4 = steelwall & boulders
; colour 5 = wall & flies
; colour 6 = amoeba
; colour 7 = slime

; I only change the colours for dirt, steelwalls & boulders, brick walls & flies
; the original colours for dirt,steel wall & boulders, brick walls & flies
; mode 33
sp33_orig
	dc.w $6d88,$4a52,$fffe

; mode 32
sp32_orig
	dc.w $44b3,$494a,$dfff

;mode 16
sp16_orig
	dc.w $53,$1c,$ff
		      
;spr_brwn32 equ  $44b3
;spr_grey32 equ  $494a
;spr_whit32 equ  $dfff


	end
