****************************************************
*
; BouQLder QLash
;
; BD_SPRT addr, sprite number
; return address for sprite
;
; (C) W. Lenerz 2018
*
*****************************************************


	section basic

	include dev8_keys_err
	include dev8_keys_sbasic
	include dev8_keys_qlv
	include dev1_basic_boulder_asm_keys

	xdef	bd_sprt
	xdef	rt_fp

	xref	bp_err

bd_sprt move.w	sb.gtlin,a2
	jsr	(a2)
	bne	bp_err
	subq.w	#2,d3
	bne	bp_err
	addq.l	#8,sb_arthp(a6)
	movem.l (a6,a1.l),d2/a5
	exg	d2,a5
	add.w	d2,d2			; entries are word sized
	move.l	spr_tbl(a5),a1		; sprite list entries table
	move.w	(a1,d2.w),d2		; index into sprite list
	move.l	spr_gen(a5),a1		; point to sprites
	add.l	a1,d2			; this is the one we want

; rt_fp: converts a long word (in d2) into a floating point
; & returns it to basic
;
rt_fp	move.l	d2,d5
	moveq	#6,d1
	move.l	sb_arthp(a6),a1
	move.w	$11a,a2
	jsr	(a2)		; get space on maths stack for return value
	move.l	d5,d2
	subq.l	#6,sb_arthp(a6)
	move.l	sb_arthp(a6),a1
rt_fp2	bsr.s	float		; convert long into float
	move.w	d0,(a6,a1.l)
	move.l	d2,2(a6,a1.l)
	moveq	#2,d4
	moveq	#0,d0
	rts

; float converts long int in d2 into floating point
; uses d2,d0

float	moveq	#0,d0
	tst.l	d2		; is it 0?
	beq.s	float2		; if 0, no need to convert
	move.w	#$0820,d0
floatlp1
	subq.w	#1,d0		; conversion long word  float
	asl.l	#1,d2
	bvc.s	floatlp1
	roxr.l	#1,d2
float2	rts

	 end
