****************************************************
*
; BouQLder QLash
; scan loop action routine : explosions
; (C) W. Lenerz 2018
*
*****************************************************

; check for explosion and hendle explosions
; in an explosion, all the explodable elements surrounding the centre of the
; explosion explode.


	section basic

	include 'dev1_basic_boulder_asm_keys'
	include 'dev1_basic_boulder_asm_snd_keys'
	include 'dev8_keys_qdos_io'

	xdef	exp_set
	xdef	explode

	xref	drw_spr
	xref	drw_blk
	xref	snd_ovr
	xref	new_spc

; Set up the explosion :
; this sets all explodable elements around the centre (a1) to explode.
; d0   r    -1 if diggeridoo is caught in the explosion, else 0
; d1	s
; d2 c	s   type of explosion (to space or to diamond)
; a1 c	s   square that's causing the explosion (ptr to array element)
; a2	s
exp_set move.l	a0,-(a7)
	moveq	#0,d0			; preset diggeridoo is ok
	lea	expl_tble,a0
	lea	-rowsize-2(a1),a2	; check elements in row above centre
	moveq	#2,d3			; 3 of them
	bsr.s	ck_expl
	lea	-2(a1),a2		; square to the left of centre
	moveq	#1,d3			; do left + centre
	bsr.s	ck_expl 		; centre of the explosion explodes, too
	tst.l	d2
	blt.s	no_neg
	neg.w	d2			; as of here, the squares are in the future
no_neg	lea	2(a1),a2		; square to the right, same row
	moveq	#0,d3
	bsr.s	ck_expl
	lea	rowsize-2(a1),a2	; check elements below
	moveq	#2,d3			; 3 of them
	bsr.s	ck_expl
	move.l	(a7)+,a0
	move.l	d0,-(a7)
	move.l	#snd_expl,d1
	bsr	snd_ovr 		; make explosion sound
	move.l	(a7)+,d0
	rts
; check whether an element is explodable, if yes, set the first expiosion sprite.
ck_expl move.w	(a2)+,d1		; element
	beq.s	expl_rf 		; is diggeridoo -> RIP
	bgt.s	expl_c1
	neg.w	d1			; unset future staus for check
expl_c1 tst.b	(a0,d1.w)		; should this element explode?
	beq.s	expl_l2 		; ... no
expl_lp move.w	d2,-2(a2)		; ... yes, show that explosion should occur
expl_l2 dbf	d3,ck_expl
done	rts
expl_rf moveq	#-1,d0			; signal diggeridoo is dying
	bra.s	expl_lp 		; show him exploding

expl_tble
.	equ	0			; element will not explode
x	equ	1			; element will explode
				  
;		0 1 2 3 4 5 6 7 8 9
	dc.b	x,x,x,x,.,x,x,x,x,x
	dc.b	x,x,x,x,x,x,x,x,x,.
	dc.b	.,.,.,.,.,.,.,.,.,x
	dc.b	x,x,x,x



; This shows the continuing explosion by changing to the appropriate sprite.
; Explosions are changed only at every second scan.
explode
	btst	#1,explo(a5)		; wait a bit before changing sprite
	bne.s	done2
	move.w	d2,d0			; current sprite
	cmp.w	#expldia,d0		; explode to diamonds ?
	bge.s	exp_dia 		; ... yes
	addq.w	#1,d2			; next sprite in chain
	cmp.w	#expldia,d2		; done?
	bne.s	setspr			; .... no
	bra	new_spc
setspr	move.w	d2,-2(a4)		; set for next scan
	move.l	d4,-(a7)
	moveq	#0,d4
	bsr	drw_spr 		; and show current sprite
	move.l	(a7)+,d4		;
done2	moveq	#0,d0
	rts
; explode to diamonds
exp_dia addq.w	#1,d2
	cmp.w	#endexdi,d2
	bne.s	setspr
	moveq	#diamond,d2
	bra.s	setspr

	end
