*********************************************************
*
; BouQLder QLash
; scan loop action routine :  make sounds using the ssss
; (C) W. Lenerz 2018
*
*********************************************************

	section sound

	xdef	sound			; play sound
	xdef	snd_ovr

	include dev1_basic_boulder_asm_keys
	include dev8_keys_sss

; d0	r   always 0
; d1 c	s   offset of sound to play
; d2 c	p  ( alternative sound if no ssss  NIY ! )
; a5 mem
sndreg	reg	d2/a0-a4
sound	movem.l sndreg,-(a7)		; keep
	movem.l ssss(a5),d0/a3
	tst.l	d0
	beq.s	no_ssss
	move.l	d0,a0
snd_tst jsr	sss_sample(a0)		; only play sound if previous is finished
	tst.l	d0
	bne.s	tst_jva
gt_spce jsr	sss_setm(a0)		; set up multiple queue (A1 & A2 return)
	move.l	a2,d2			; end of queue
	sub.l	a1,d2			; that much space in sound queue
	lsr.l	#1,d2			; nbr of words available in queue
	beq.s	no_ssss 		; ooops, none!
	move.l	d1,cur_snd(a5)
	add.l	snd_dta(a5),d1		; ptr to sound
	move.l	d1,a4
	moveq	#0,d1
	move.w	(a4)+,d1		; nbr of words
	cmp.l	d1,d2
	ble.s	snd_cpy 		; take the smaller of both
	move.l	d1,d2
snd_cpy subq.w	#1,d2
snd_lp	move.w	(a4)+,(a1)+
	dbf	d2,snd_lp

play	jsr	sss_addm(a0)		; add these bytes to ssss
tst_jva tst.b	machine(a5)		; smsqmulator ?
	bne.s	no_ssss 		; ... no
	jsr	24(a0)			; smsqmulator specific
no_ssss movem.l (a7)+,sndreg		; keep
	clr.l	d0
	rts

; normally, a sound is only played if the previous one is finished.
; an explosion, though, is always played (unless another explion is already playing)
snd_ovr movem.l sndreg,-(a7)		; keep
	movem.l ssss(a5),d0/a3
	tst.l	d0
	beq.s	no_ssss
	move.l	d0,a0
	cmp.l	cur_snd(a5),d1		; was/is explosion playing?
	beq.s	snd_tst 		; ... yes, check if this one should be played
	bra.s	gt_spce 		; ... no, this this will always play
	end
