****************************************************
*
; BouQLder QLash
; 1 - Draw all or part of the status bar
; 2 - BD_PRINT keyword
; (C) W. Lenerz 2018
*
*****************************************************

; the alphanum sprites are real uncompressed mode 16 smsqe sprites, each sprite
; is 296 bytes long

	section basic

	include 'dev1_basic_boulder_asm_keys'
	include 'dev1_basic_boulder_asm_snd_keys'
	include 'dev8_keys_qlv'
	include 'dev8_keys_err'
	include 'dev8_keys_sbasic'
	include 'dev8_keys_qdos_io'
	include 'DEV8_keys_qdos_sms'

	xdef	drw_status
	xdef	drw_req
	xdef	drw_time
	xdef	drw_score
	xdef	inc_score
	xdef	bd_print
	xdef	bd_status

	xref	sound
	xref	cvt_lng

; draw the entire status bar (diamonds needed, dia val,dias got, time, score)
drw_status
	bsr	drw_req
	bsr	drw_val
	bsr.s	drw_dgot
	bsr.s	drw_time
	bra.s	drw_score		; return directly from there

; what to draw when nbr of diams increases : nbr of diams got, total score
inc_score
	movem.l a1/a2,-(a7)
	bsr.s	drw_dgot
	bsr.s	drw_score
	move.l	#snd_diac,d1
	bsr	sound
	movem.l (a7)+,a1/a2
	rts
 
; d3	s
; a1	s  ptr to string (length word + data)
; a5 c p   mem area
; draw nbr of diamonds gpt
drw_dgot
	lea	buffer(a5),a1
	move.l	#$00033030,(a1)+	; length of string + prefill with '0
	move.b	#$30,(a1)+
	moveq	#0,d0			; right justify
	moveq	#0,d1
	move.w	dia_got(a5),d1		; nbr of diamonds got
	bsr	cvt_lng 		; convert to ascii
	lea	buffer(a5),a1
	move.l	spr_ayl(a5),a2		; white sprite
	move.w	xo_dgot(a5),d1
	bra.s	drw_str 		; draw & return

; draw the score
drw_score
	lea	buffer(a5),a1
	move.l	#$00063030,(a1)+	; length of string + prefill with '0
	move.l	#$30303030,(a1)+
	moveq	#0,d0			; right justify
	moveq	#0,d1
	move.l	points(a5),d1		; score
	bsr	cvt_lng 		; convert to ascii
	lea	buffer(a5),a1
	move.l	spr_awh(a5),a2		; white sprite
	move.w	xo_pnts(a5),d1
	bra.s	drw_str

; draw the time
drw_time
	lea	buffer(a5),a1
	move.l	#$00033030,(a1)+	; length of string + prefill with '0
	move.b	#$30,(a1)+
	moveq	#0,d0			; right justify
	moveq	#0,d1
	move.w	time(a5),d1		; time remaining
	bge.s	dt_ok
	moveq	#0,d1
dt_ok
	bsr	cvt_lng 		; convert to ascii
	lea	buffer(a5),a1
	move.l	spr_awh(a5),a2		; white sprite
	move.w	xo_time(a5),d1


; draw a string
    
; d1 c	s  column where string starts
; a1 c	s  ptr to string (length word + data)
; a2 c p   ptr to sprites, spaced 296 bytes apart
; a5 c p   mem area
ds_regs reg	d2/d3/d4/a0
drw_str movem.l ds_regs,-(a7)
	moveq	#0,d4
drwstr2 moveq	#-1,d3
	move.l	chanID(a5),a0
	move.w	(a1)+,d2
	bra.s	ds_loop
ds_1chr bsr.s	drw_char
	addq.w	#1,d1
ds_loop dbf	d2,ds_1chr
	movem.l (a7)+,ds_regs
	rts


; draw one character - if char is space, do nothing

; d1 c p   column where string starts (col width = in sp_wsiz(a5)
; d3 c p   -1
; a0 c p   channel ID
; a1 cr    ptr to char | ptr after char (bytewise)
; a2 c p   ptr to sprites, spaced 296 bytes apart
; a5 c p   mem area
dc_regs reg	d1/a1
drw_char
	move.b	(a1)+,d0
	cmp.w	#32,d0
	beq.s	dc_out
	movem.l dc_regs,-(a7)
	move.l	a2,a1
	sub.w	#48,d0			; my character set starts at '0'
	cmp.w	#43,d0			; beyond 'Z'?
	blt.s	no_low			; ... no, ok
	sub.w	#32,d0			; ... yes, lc -> UC
	cmp.w	#42,d0			; upper case printable?
	bgt.s	dc_out			; ... no
no_low	cmp.w	#11,d0
	ble.s	dc_alf
	subq.w	#6,d0			; pretty non standard character set...
dc_alf	mulu	#296,d0
	add.l	d0,a1			; point to sprite
	mulu	sp_xsiz(a5),d1		; x orig
	swap	d1
	move.w	d4,d1			; y orig
	moveq	#iop.wspt,d0
	trap	#3
	movem.l (a7)+,dc_regs
dc_out	rts

 
; d3	s
; a1	s  ptr to string (length word + data)
; a5 c p   mem area
; draw required nbr of diamonds and diamond value
drw_req
	lea	buffer(a5),a1
	move.l	#$00023030,(a1)+	; length of string + prefill with '0
	moveq	#0,d0			; right justify
	moveq	#0,d1
	move.w	dia_req(a5),d1		; nbr of diamonds required
	bsr	cvt_lng 		; convert to ascii
	lea	buffer(a5),a1
	move.l	spr_ayl(a5),a2		; yellow sprite
	move.w	xo_dreq(a5),d1
	bra	drw_str 		; draw & return

; draw separator and diamond value
drw_val
	lea	buffer(a5),a1
	move.l	#$00033a30,(a1)+	; length of string + prefill with '0
	move.b	#$30,(a1)+
	moveq	#0,d0			; right justify
	moveq	#0,d1
	move.w	dia_val(a5),d1		; nbr of diamonds required
	bsr	cvt_lng 		; convert to ascii
	lea	buffer(a5),a1
	move.l	spr_awh(a5),a2		; yellow sprite
	move.w	xo_dreq(a5),d1
	addq.w	#2,d1
	bra	drw_str 		; draw & return

******************************************************
*
*	BD_STATUS address
*	print entire status bar
*
******************************************************
bd_status
	move.w	sb.gtlin,a2
	jsr	(a2)			; get 3 long ints
	bne.s	errbp
	subq.w	#1,d3			; exactly 3?
	addq.l	#4,sb_arthp(a6) 	; reset math stack ptr
	move.l	(a6,a1.l),a5
	bsr	drw_status
	moveq	#0,d0
	rts

******************************************************
*
*	BD_PRINT address,sprite_address,row | col,string_to_print$
*	row is in pixels, col in sprite size!!!!!!
*
******************************************************
errbp	moveq	#err.ipar,d0
	rts
bd_print
	subq.l	#8,a5
	move.w	sb.gtlin,a2
	jsr	(a2)			; get  3 long ints
	bne.s	errbp
	subq.w	#3,d3			; exactly 3?
	bne.s	errbp			; ... no
	move.l	a5,a3
	addq.l	#8,a5			; point last param
	move.w	sb.gtstr,a2
	jsr	(a2)			; try to get one string
	subq.w	#1,d3
	bne.s	errbp			; ... couldn't!
	moveq	#0,d0
	add.l	a6,a1
	move.w	(a1),d0 		; length of string
	addq.w	#3,d0			; + make even
	bclr	#0,d0
	move.l	d0,a3
	add.w	#12,d0			; size of 3 long words
	add.l	d0,sb_arthp(a6) 	; reset math stack ptr
	add.l	a1,a3			; point after string
	movem.l (a3),d1/a2/a5
	exg	d1,a5			, d1 = col, a5 =main mem , a2=sprites
	move.l	d1,d4
	swap	d4
	mulu	sp_ysiz(a5),d4
	pea	bdp_out 		; do not use bsr here...
	movem.l ds_regs,-(a7)		; ... because of this
	bra	drwstr2 		; this returns to instruction below
bdp_out moveq	#0,d0
	rts

	end
